package com.steerinfo.meterwork.meterworkgrabactual.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkcaractualfirst.model.MeterWorkCarActualFirst;
import com.steerinfo.meterwork.meterworkgrabactual.model.MeterWorkGrabActual;
import com.steerinfo.meterwork.meterworkgrabactual.service.IMeterWorkGrabActualService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkGrabActual RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-06-27 11:26
 * 类描述
 * 修订历史：
 * 日期：2021-06-27
 * 作者：generator
 * 参考：
 * 描述：MeterWorkGrabActual RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkgrabactuals")
public class MeterWorkGrabActualController extends BaseRESTfulController {

    @Autowired
    IMeterWorkGrabActualService meterWorkGrabActualService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkgrabactual:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkGrabActual> list = meterWorkGrabActualService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkgrabactual:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkGrabActual> list = meterWorkGrabActualService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkGrabActual对象创建")
    @ApiImplicitParam(name = "meterWorkGrabActual", value = "详细实体meterWorkGrabActual", required = true, dataType = "MeterWorkGrabActual")
    //@RequiresPermissions("meterworkgrabactual:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkGrabActual model){
        MeterWorkGrabActual meterWorkGrabActual = meterWorkGrabActualService.add(model);
        return success(meterWorkGrabActual);
    }

    @ApiOperation(value = "新增数据", notes = "根据MeterWorkGrabActual对象创建")
    @ApiImplicitParam(name = "meterWorkGrabActual", value = "详细实体MeterWorkGrabActual", required = true, dataType = "MeterWorkGrabActual")
    @PostMapping(value = "/add")
    public RESTfulResult chechandadd(@RequestBody MeterWorkGrabActual model) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkGrabActualService.checkandadd(model);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("新增失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }


    @ApiOperation(value = "修改数据", notes = "根据MeterWorkGrabActual对象创建")
    @PostMapping(value = "/update")
    public RESTfulResult chechandupdate(@RequestBody MeterWorkGrabActual model) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkGrabActualService.checkandupdate(model);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("修改失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkgrabactual:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkGrabActual meterWorkGrabActual = meterWorkGrabActualService.getById(id);
        return success(meterWorkGrabActual);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkGrabActual信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkGrabActual", value = "详细实体meterWorkGrabActual", required = true, dataType = "MeterWorkGrabActual")
    })
    //@RequiresPermissions("meterworkgrabactual:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkGrabActual model){
        model.setId(id);
        MeterWorkGrabActual meterWorkGrabActual = meterWorkGrabActualService.modify(model);
        return success(meterWorkGrabActual);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkgrabactual:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkGrabActualService.delete(ids);
    	}
      return success();
    }
}
